----------------------------------------------
--		Serenity Now						--
--			By Shampow on US-Archimonde		--
----------------------------------------------

SN = LibStub("AceAddon-3.0"):NewAddon("SerenityNow", "AceEvent-3.0", "AceTimer-3.0",  "AceConsole-3.0")
SN.ver = "0.91rc8"

SN.LSM = LibStub("LibSharedMedia-3.0")

--SN.timers = LibStub("LibFancyBar-1.0")
SN.timers = LibStub("LibCandyBar-3.0")

SN.dispel = LibStub("LibDispellable-1.0")

local AceConfig = LibStub("AceConfig-3.0")
local AceConfigDialog = LibStub("AceConfigDialog-3.0")
local AceDB = LibStub("AceDB-3.0")
local AceDBOptions = LibStub("AceDBOptions-3.0")

local RaidRoster = {}
CDVisible = {}
DBVisible = {}

-- Frames
SN.F = {}
 	
SN.V = LibStub("AceDB-3.0"):New("SNDB", defaults, true)

-- How often the OnUpdate code will run (in seconds)
SN_UpdateInterval = 1.0 

--Are our frames locked?
frameLocked = 1

--local glyphCooldowns = {
--	[63229] = {47585, 15},     -- Dispersion, -15sec
--	[55455] = {2894, "40"},    -- Fire Elemental Totem, -40%
--	[63329] = {871, -120},     -- Shield Wall, +2min
--	[55688] = {64044, 10},     -- Psychic Horror, -10sec
--	[58058] = {556, 300},      -- Astral Recall, -300sec
--	[58673] = {48792, "30"},   -- Icebound Fortitude, -50%
--	[58686] = {47528, 2},      -- Mind Freeze, -2sec
--	[116203] = {16689, 30},    -- Nature's Grasp, -30sec
--	[114223] = {61336, 60},    -- Survival Instincts, -60sec
--	[62210] = {12042, "-100"}, -- Arcane Power, +100%
--}

function SN:OnEnable()
	--Timer Groups
	SN:Debuffs()
	SN:CoolDowns()
	
	--Setup Power Bar
	SN:SetupPower()
	--Setup Threat module
	--SN:SetupThreat()
	SN:SetupDispel()
	SN.db.profile.Frames.lock = true
end


function SN:OnInitialize()

	SN.bloodlustId = UnitFactionGroup("player") == "Alliance" and 32182 or 2825
	SN.playerClass = select(2, UnitClass("player"))

	--Setup the clc 
	SN:RegisterChatCommand("sn", "Cmds")

	--Check to see if ElvUI is loaded so we can make the bars purty
	if (IsAddOnLoaded("ElvUI")) then
		local E, L, V, P, G, _ = unpack(ElvUI)
	end

	--Add CD/DB/Threat list to the database
	SN:setupCDList()
	--SN:setupThreatList()
	SN:SetupOptions()

	--Register this here because bad things happen if it isn't
	SN:RegisterEvent("UNIT_DISPLAYPOWER", "EventHandler")
	SN:RegisterEvent("GROUP_ROSTER_UPDATE", "EventHandler")

	--start the collecter
	collectgarbage("collect")

	--Lets make the welcome message more visible
	SN:ScheduleTimer("Ver", 10)

end

function SN:Ver()
	print(format("Welcome to |cff0070deSerenity Now|r".." "..SN.ver))
end

function SN:Cmds(input)

	local v1, v2 = input:match("^(%S*)%s*(.-)$")
	v1 = v1:lower()

	if (v1 == "") then	
		print("|cff0070deSerenity Now|r "..SN.ver)
		print("/sn |cff0070deconfig|r - open the config frame.")
		print("/sn |cff0070delock|r - unlock/lock the frames.")
		print("/sn |cff0070dereset|r - reset the frames.")

	elseif (v1 == "options") or (v1 == "config") or (v1 == "opt") or (v1 == "o") then
		InterfaceOptionsFrame_OpenToCategory("Serenity Now")
	elseif (v1 == "lock") or (v1 == "unlock") or (v1 == "drag") or (v1 == "move") or (v1 == "l") then
		if SN.db.profile.Frames.lock then
			SN:MoveFrames(false)
			SN.db.profile.Frames.lock = false
			print("Frames Unlocked")
		else
			SN:MoveFrames(true)
			SN.db.profile.Frames.lock = true
			print("Frames Locked")
		end
	elseif (v1 == "reset") or (v1 == "defaults") then
		ResetAnchors()
	else
		print("command not known.")
	end
end

function SN:CheckGlyphs(cooldown)
	checkglyphs = false
	for i = 1, NUM_GLYPH_SLOTS do
		local enabled, glyphType, glyphTooltipIndex, glyphSpellID, icon = GetGlyphSocketInfo(i)
		if ( enabled ) then
			if cooldown['glyphid'] == glyphSpellID then
				checkglyphs = true
			end
		end
	end
	return checkglyphs
end

function SN:Debug(...)
	if SN.db.profile.debug.enable then
		SN:Print(...)
	end
end